import akka.actor.ActorRef;
import akka.actor.Props;
import akka.actor.UntypedActor;

import java.util.ArrayList;
import java.util.List;

public class Collector extends UntypedActor {
  private int _count = 0;
  private long start = System.nanoTime();
  private int _pending = 0;
  List<ActorRef> _slaves = new ArrayList<>();

  @Override
  public void preStart() {
    for(int i = 0; i < 100; i++) {
      ActorRef slave = getContext().system().actorOf(new Props(ExploreFile.class));
      _slaves.add(slave);
    }
  }

  @Override
  public void onReceive(final Object message) {
    if(message instanceof String) {
      _pending++;
      ActorRef slave = _slaves.remove(0);
      slave.tell(message, self());
      _slaves.add(slave);
    }

    if(message instanceof Integer) {
      _pending--;
      _count += (Integer)(message);
      if(_pending == 0) {
        System.out.println("Total number of files: " + _count);
        System.out.println("Time taken: " + (System.nanoTime() - start)/1.0e9);
        getContext().system().shutdown();
      }
    }
  }
}
